#ifndef _ERR_DEFINED
#define _ERR_DEFINED

/* messages in errorsys */
#define EG_MSG_QUIT    "Quit"
#define EG_MSG_RETRY   "Retry"
#define EG_MSG_DEFAULT "Default"

/* severity codes for error object */
#define ES_WHOCARES   		0
#define ES_WARNING    		1
#define ES_ERROR      		2
#define ES_CATASTROPHIC		3

/* genCode */
#define EG_ARG				1
#define EG_BOUND			2
#define EG_STROVERFLOW			3
#define EG_NUMOVERFLOW			4
#define EG_ZERODIV			5
#define EG_NUMERR			6
#define EG_SYNTAX			7
#define EG_COMPLEXITY			8

#define EG_MEM				11
#define EG_NOFUNC			12
#define EG_NOMETHOD			13
#define EG_NOVAR			14
#define EG_NOALIAS			15
#define EG_NOVARMETHOD			16
#define EG_BADALIAS			17
#define EG_DUPALIAS      		18

#define EG_CREATE			20
#define EG_OPEN				21
#define EG_CLOSE			22
#define EG_READ				23
#define EG_WRITE			24
#define EG_PRINT			25

#define EG_UNSUPPORTED 			30
#define EG_LIMIT			31
#define EG_CORRUPTION			32
#define EG_DATATYPE			33
#define EG_DATAWIDTH			34
#define EG_NOTABLE			35
#define EG_NOORDER			36
#define EG_SHARED			37
#define EG_UNLOCKED			38
#define EG_READONLY			39
#define EG_APPENDLOCK			40
#define EG_LOCK  			41
#define EG_SIGNAL  			42

#endif
